 

import greenfoot.Greenfoot;

public class Curve extends Fragment {

	private final static int ROTATION_DEGREE = 20;
	private final static int SPEED = 8;

	private boolean dead;
	private Player player;
	private int size;
	private int startSize;

	static Clock clock;

	public Curve(Player player) {
		super(player.getColor());
		this.player = player;
		this.dead = false;
		this.startSize = Greenfoot.getRandomNumber(3) + 3;
		this.size = this.startSize;
		
	}

	public void act() {
		if (this.dead) {
			return;
		}
		if (clock != null && !clock.isNull()) {
			return;
		}
		clock = null;

		if (Greenfoot.isKeyDown(player.getMinusKey())) {
			setRotation(getRotation() - ROTATION_DEGREE);
		}
		if (Greenfoot.isKeyDown(player.getPlusKey())) {
			setRotation(getRotation() + ROTATION_DEGREE);
		}
		ahead();
	}
	
	void stop() {
	    dead = true;
	   }

	private void ahead() {
		double angle = Math.toRadians(getRotation());
		int oldX = getX();
		int oldY = getY();
		int newX = (int) Math.round(getX() + Math.cos(angle) * SPEED);
		int newY = (int) Math.round(getY() + Math.sin(angle) * SPEED);

		// check border
		if (newX < 0 || newX >= getWorld().getWidth()-CurvesWorld.BORDERWIDTH || newY < 0
				|| newY >= getWorld().getHeight()) {
			this.dead = true;
			((CurvesWorld) this.getWorld()).dead(this.player);
			return;
		}

		// check collision
		if (this.getOneIntersectingObject(Fragment.class) != null) {
			dead = true;
			((CurvesWorld) this.getWorld()).dead(this.player);
			return;
		}

		// ok: extending the curve
		size++;
		if (size > startSize) {
			Fragment fragment = new Fragment(this.getColor());
			this.getWorld().addObject(fragment, oldX, oldY);
			if (size == 50) {
			    this.startSize = Greenfoot.getRandomNumber(5) + 1;
				size = 0;
			}
		}

		this.setLocation(newX, newY);
	}

	static void startClock() {
		clock = new Clock(2000);
	}
}
